/* hash.h: generic object-oriented interface to all hash functions */

#ifndef HASH_H
#define HASH_H

struct hash_object_s {
  void *data;    /* private data */
  int hash_len;  /* length of hash value in bytes */
  void (*hash_init)(void *data);
  void (*hash_byte)(void *data, int x);
  void (*hash_bytes)(void *data, unsigned char *p, int n);
  void (*hash_finish)(void *data);
  void (*hash_finish_with_bits)(void *data, int n, unsigned char bits);
  void (*hash_gethash)(void *data, unsigned char *p);
  void (*hash_free)(struct hash_object_s *self);
};
typedef struct hash_object_s hash_object_t;

#endif /* HASH_H */
